###################################
# (C) Copyright International Business Machines (IBM), 2001, 2002, 2005
# Useable and distributable only with IBM permission and under IBM terms and
# conditions. It may not be copied or further distributed unless authorized in
# writing by IBM.
###################################

# use strict;
# use diagnostics -verbose;

my $STATUSTEXT = 0;
my $DIALOG     = 1;
my $ONEINSERT  = 1;
my $TWOINSERT  = 2;
###########################################################################
# display_message
#
# Function: displays a message - either on message line or popup
#
# Input: Key in the hash
#	This key is used to pull back the data from the hash. The format of this is
#	text to be displayed:0 or 1: 0 or 1 or 2
#	if the second column is 0, it is a status bar message. 1 is a popup box
#	if number in the last column is the number of inserts to be replaced
#
###########################################################################
sub display_message($) {

    # local variables
    my $message_text;
    my $type;
    my $insert;
    my $mw;
    my ($key) = @_; # get the key passed in
                    # split out the text, type, insert indicator, seperated by :
    ( $message_text, $type, $insert ) =
      split( ":", $portManager::messages{$key} );

#check and see if we need to replace any inserts, otherwise, we just use the given text
    if ( $insert == $ONEINSERT ) {
        $message_text =~ s/<insert1>/$portManager::insert1/g;
    }
    elsif ( $insert == $TWOINSERT )    #two inserts to put into the message
    {
        $message_text =~ s/<insert1>/$portManager::insert1/g;
        $message_text =~ s/<insert2>/$portManager::insert2/g;
    }

    if ( $type == $STATUSTEXT ) {
        $portManager::statusText = $message_text;
    }                                  # print out to the status bar
    elsif ( $type ==
        $DIALOG )    # if dialog type, put up the popup with the error message
    {

        my $ew = $portManager::mw->Dialog(
            -title  => 'SourceCheckingTool Error',
            -text   => $message_text,
            -bitmap => 'warning'
        );
        $ew->Show('-global');

    }

    return;          # return to caller
}
1;
