#!/bin/bash
#
# Linux Compatablity Tool Endian data size differences checker
#

if [[ -z ${DB} ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

if [[ -z ${OBJDUMP} ]]
then
    echo "Missing assignment"
    echo "    OBJDUMP environment variable not set"
    exit 1
fi

if [[ -z ${ECTBIN} ]]
then
    echo "Missing assignment"
    echo "    ECTBIN environment variable not set"
    exit 1
fi

if [[ -z ${EXEFILE} ]]
then
    echo "Missing assignment"
    echo "    EXEFILE environment variable not set"
    exit 1
fi


typeset -i -x LCOUNT

LCOUNT=`gawk -f  ${ECTBIN}/chkdatatypes.awk ${OBJDUMP} | wc -l`

while [ $LCOUNT -gt 0 ]
do
FLINE=`cat -n ${OBJDUMP} | gawk '{\
if ($0 ~ "long *double")
    {
     if (match($0,"/[*][[:print:]]*bitsize[[:print:]]*[*]/"))
     {
        next
     }
     if (match($0,"[.]long[  ]*"))
     {
        next
     }
     if (match($0,"typedef "))
     {
        next
     }
     if (match($0,"/[*][  ]*0x[[:print:]]* *[*]/"))
     {
        next
     }
     print $0
     LINES++
     args++
     next
     getline
     while ($0 !~ "[[:print:]]*:")
     {
         if ($0 ~ "long *double")
         {
            print $0
            LINES++
         }
         getline
     }
     args++
  }
}'| head -$LCOUNT | tail -1 |sed 's/^[[:blank:]]*//' | gawk '{print $0}'`

OBJLINE=`echo "$FLINE" | gawk -F "\t" '{print $1}'`
SOURCELINE=`echo "$FLINE" | gawk -F "\t" '{print $2}'`
# echo "OBJLINE is ""$OBJLINE"
SOURCEFILE=`head -$OBJLINE ${OBJDUMP} | nl | sort -rn | ggrep  "[.][[:print:]]*:[0-9][0-9]*$" > /dev/null | head -1 | gawk -F "\t" '{print $2}' | gawk -F ":" '{print $1}'`

if [ x"$SOURCEFILE" != x ]
then
	GREPRES=`ggrep -n -F "$SOURCELINE" $SOURCEFILE | head -1`
	SOURCELINEOUT=`echo "$GREPRES" | gawk -F ":" '{print $1}'`

	echo -e "${SOURCEFILE}\t${SOURCELINEOUT}\tW70001\tInconsistent Data Size for: long double" >> ${DB}/tSourceMsgs.tbl

fi
LCOUNT=`expr $LCOUNT - 1`
done


exit
