#!/bin/bash

# Usage:
#    Switches:
#    Parameters:
#       1: Executable (full file spec)
#       2: Result filespec (full)

# Save the current binary directory ... for the too

# case sensitivity CE
#
#[ "$LANG" != C ] && echo "WARNING!!! LANG Environment variable set wrong."
echo "0% Complete [`date +%H:%M:%S`] - Staring ..."
machtype=`echo $MACHTYPE | gawk '/redhat/ { print "RH"}; /suse/ { print "SU" }'`
if [ "$machtype" == "RH" ]
then
	echo $MACHTYPE
	cat /etc/redhat-release
elif [ "$machtype" == "SU" ]
then
	echo  $MACHTYPE
	cat /etc/SuSE-release
else
	echo  $MACHTYPE
	echo "version unknown"
fi

echo "This might take a long time to complete.. please do not interrupt it.."
export LANG=C

#gdbver=`rpm -qa | grep gdb- | awk -F. '{print $1}' | awk -F'-' '{print $2}'`
#gdbver=`pkginfo -l CSWgdb | ggrep VERSION | awk '{print $2}' | awk -F',' '{print $1}'`
gdbver=`pkginfo -l SFWgdb | ggrep VERSION | awk '{print $2}' | awk -F',' '{print $1}'`
export GDB_VERSION=$gdbver

#
# end case sensitivity change
    export ECTBIN=`dirname $0`
    if [[ "${ECTBIN}" = "." ]]
    then
	export ECTBIN=`pwd`
    fi

    export ECT=`dirname $ECTBIN`
    export RESFILE=$2

# Make sure we were given a source exe file name ... and that it exists ...
    if [[ "${1}t" = "t" ]]
    then
	echo "Did not receive source file ${1} ..." >&2
	exit 1
    fi

    if [[ "${2}t" = "t" ]]
    then
	echo "Did not receive result file ${2} ..." >&2
	exit 1
    fi

    if [[ ! -r $1 ]]
    then
	echo "$1 is not a readable file" >&2
	exit 1
    fi

# Save the location of the source (if provided) ...
    export EXEFILE=$1
    export EXENAME=`basename $1`

# Make sure we have an executable
    file $EXEFILE | ggrep -i executable 2>&1 > /dev/null
    isexetxt=$?
    if [[ "${isexetxt}" != "0" ]]
    then
	echo "File is not executable: ${EXEFILE}"
	echo "File details:"
	file ${EXEFILE}
	echo "This tool expects to run on a binary executable,"
	echo "please adjust your usage and re-run"
	exit 1
    fi

# Is it stripped?
    file $EXEFILE | ggrep -i "not stripped" 2>&1 > /dev/null
    isstripped=$?
    if [[ "${isstripped}" != "0" ]]
    then
	echo "Executable file has been stripped: ${EXEFILE}"
	echo "File details:"
	file ${EXEFILE}
	echo "This tool expects to run on a binary executable"
	echo "that has been built with gcc using -gstabs+ -save-temps switches,"
	echo "please adjust your usage and re-run"
	exit 1
    fi

# Create the working directory for the tool to track data
    export DB=${ECT}/data/${EXENAME}.DB

# Remove all existing database files and result files
    rm -f $RESFILE
    rm -rf ${DB}

    if [[ -d ${DB} ]]
    then
	for tblfile in `ls ${DB}/*`
	do
	    rm $tblfile
	    sts=$?
            if [ -e $tblfile ]
	    then
		echo "Unable to remove old `basename $tblfile`: $tblfile: status $sts" >&2
		exit $sts
	    fi
	done
    fi
    mkdir -p ${DB}

# Run objdump ... and remember where we put it ...
    PSERIESSYN="	bl	"
    INTELSYN="	call "
    export OBJDUMP=${DB}/objdump.txt

#    gobjdump --demangle=none -S -t -T -x -l -g -s ${EXEFILE} > ${OBJDUMP}.tmp 2> /dev/null
    gobjdump -S -t -T -x -l -g -s ${EXEFILE} > ${OBJDUMP}.tmp 2> /dev/null
    
    echo ${ECTBIN}/trim.exe  ${OBJDUMP}.tmp ${OBJDUMP}.tmp2
echo break?
    read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else
    ${ECTBIN}/trim.exe  ${OBJDUMP}.tmp ${OBJDUMP}.tmp2
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    
    echo gc++filt \< ${OBJDUMP}.tmp2 \> ${OBJDUMP}
echo break?
    read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else
    gc++filt < ${OBJDUMP}.tmp2 > ${OBJDUMP} 2> /dev/null
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    
#    rm -f ${OBJDUMP}.tmp ${OBJDUMP}.tmp2

    #CALLCNT=`gobjdump --demangle=none -S -t -T -x -l -g -s ${EXEFILE} 2>/dev/null | gc++filt | tee  ${OBJDUMP} | gegrep -c "$PSERIESSYN|$INTELSYN" `

    srchpath=/lib:/usr/lib
    if [[ ! -z "${LD_LIBRARY_PATH}" ]]
    then
	srchpath=${LD_LIBRARY_PATH}:${srchpath}
    fi
# Need to verify that we have all shareable libraries available
    sts=0
    needed=`ggrep "^  NEEDED " ${OBJDUMP} | sed 's/ NEEDED / /g'`
    echo "NEEDED next:\n"
    echo ${needed}
    if [[ ! -z "${needed}" ]]
    then
	for lib in `echo ${needed}`
	do
	    found=0
	    for dir in `echo ${srchpath} | sed 's/:/ /g'`
	    do
		if [[ -e "${dir}/${lib}" ]]
		then
		    found=1
		    break
		fi
	    done
	    if [[ "${found}" = "0" ]]
	    then
		sts=1
		echo "Did not find ${lib} in shared library search path ${srchpath}"
	    fi
	done

	if [[ "${sts}" != "0" ]]
	then
	    echo ""
	    echo "Please adjust your LD_LIBRARY_PATH to include the directories"
	    echo "where the libraries mentioned above may be found"
	    exit 1
	fi
    fi

    echo "Using ..."
    echo "      ECT Bin direct:  $ECTBIN"
    echo "      executable file: $EXEFILE"
    echo "      results file:    $RESFILE"
    echo "      database direct: $DB"
    echo "      objdump file:    $OBJDUMP"

# Generate a size table for determining type sizes 
echo    ${ECTBIN}/generate_sizes.bash $OBJDUMP ${ECTBIN}
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/generate_sizes.bash $OBJDUMP ${ECTBIN}
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "10% Complete [`date +%H:%M:%S`] - generated size table..."

# Run the bash script to store the function definitions and parameters
echo    ${ECTBIN}/funcdef.bash
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/funcdef.bash
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    sts=$?
    if [[ ${sts} != 0 ]]
    then
        echo ""
	echo "Error obtaining function definitions" >&2
	exit $sts
    fi
    echo ""
    echo "20% Complete [`date +%H:%M:%S`] - generated function definitions table..."

# Run the script to store the function references
echo    ${ECTBIN}/funcref.bash ${OBJDUMP} ${EXEFILE} 
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/funcref.bash ${OBJDUMP} ${EXEFILE} 
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo ""
    echo "30% Complete [`date +%H:%M:%S`] - generated function references table..."

# Look for potentially hazardous routine calls
echo    ${ECTBIN}/chkapi.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/chkapi.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "40% Complete [`date +%H:%M:%S`] - checked for risky API calls..."

# Look for ioctl calls
echo    ${ECTBIN}/chkioctl.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/chkioctl.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "50% Complete [`date +%H:%M:%S`] - checked for ioctl usage..."

# Look for endian errors in calls
echo   ${ECTBIN}/chkendian_calls.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
   ${ECTBIN}/chkendian_calls.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "60% Complete [`date +%H:%M:%S`] - checked for endian errors in function calls..."

# Look for endian errors in global variable declarations
echo   ${ECTBIN}/chkendian_globals.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
   ${ECTBIN}/chkendian_globals.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "70% Complete [`date +%H:%M:%S`] - checked for endian errors in global variable  declarations..."

# Look for known data size issues
echo   ${ECTBIN}/chkdatasizes.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
   ${ECTBIN}/chkdatasizes.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "80% Complete [`date +%H:%M:%S`] - checked for data size differences..."

# Look for usages of __BUILTIN that we do not expect
echo   ${ECTBIN}/chkintrinsics.bash # Uses current $DB for info
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
   ${ECTBIN}/chkintrinsics.bash # Uses current $DB for info
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
    echo "90% Complete [`date +%H:%M:%S`] - checked for potentially invalid uses of __BUILTIN..."

# Tweak the output for the GUI
    cat ${DB}/tFunctionDef.tbl | gawk -F"	" '{print $6}' | \
	ggrep -v "<NULL>" | sort -u > ${RESFILE}.tmp
    sort -u ${DB}/tSourceMsgs.tbl >> ${RESFILE}.tmp
    rm -f ${RESFILE}

    sort -t"	"  -k1,1 -k2n ${RESFILE}.tmp > ${RESFILE}

    # Generate the listing
    rm -f ${EXENAME}.report
    if [[ -e ${RESFILE} ]]
    then
	cat ${RESFILE} | sed 's/	/ - Line: /' >> ${EXENAME}.report
    else
	echo "Results file ${EXENAME} did not get created"
	exit 1
    fi

    echo "100% Complete [`date +%H:%M:%S`] - Formulated results ..."

# Display the summary information
echo    ${ECTBIN}/summary.bash
read -n1 shouldbreak
if [ "$shouldbreak" == "y" ]
then
    bash
else    
    ${ECTBIN}/summary.bash
echo break?
    read -n1 shouldbreak
    if [ "$shouldbreak" == "y" ]
	then
	    bash
    fi
fi
