#!/bin/bash

# Save the current binary directory ... for the tools
    export ECTBIN=`dirname $0`
    if [[ "${ECTBIN}" = "." ]]
    then
	export ECTBIN=`pwd`
    fi
    export ECT=`dirname $ECTBIN`
    if [[ "${ECT}" = "." ]]
    then
	export ECT=`pwd`
    fi

# Make sure folks in our group can override our files
    umask 002 

# If we were supplied an existing file, run the tool ...
    if [[ -r $1 ]]
    then
	echo "Starting Linux Cross-Platform Compatibility Tool - text mode"
	echo "Please wait ..."
	echo ""
	echo ""
	cat ${ECT}/doc/Welcome.txt
	echo ""
	echo ""
	EXENAME=`basename $1`
	export PATH=$PATH:${ECTBIN}
	time ${ECTBIN}/ect.bash $1 ${EXENAME}.ect
    else

# Make sure we have a DISPLAY variable
	if [[ -z ${DISPLAY} ]]
	then
	    echo "DISPLAY is not set. Please set and re-run..." >&2
	    exit 1
	fi

	echo "Starting Linux Cross-Platform Compatibility Tool - graphical mode"
	echo "Please wait ..."
	java -D"ECT=${ECT}" -D"WARN=#00008b" -D"ERROR=#ff1493" \
	    -cp ${ECTBIN}/ectgui.jar com.ibm.ect.java.EctMain
#	The following colors can be used for WARN or ERROR:
#	#00ffff Aqua
#	#000000 Black
#	#0000ff Blue
#	#a52a2a Brown
#	#d2691e Chocolate
#	#dc143c Crimson
#	#00ffff Cyan
#	#00008b Dark Blue
#	#bdb76b Dark Khaki
#	#9932cc Dark Orchid
#	#e9967a Dark Salmon
#	#8fbc8f Dark SeaGreen
#	#00bfff Deep Skyblue
#	#ff1493 Deep Pink
#	#808080 Gray
#	#008000 Green
#	#20b2aa Light Sea Green
#	#ffc0cb Pink
#	#ff0000 Red
#	#ffff00 Yellow
#	#ee82ee Violet
#	#f5deb3 Wheat
#	#9acd32 Yellow Green
    fi
