#!/bin/bash

## The following is just a function called later
PrintRecord()
{
  i=0
  while [ $i -lt ${FIELDS} ]
  do
    printf "%s	" "${OutRecord[i]}" 1>> $FUNCTIONREFTBLE
    let "i=$i+1"
  done
  printf "%s	%s\n" "${OutRecord[i]}" "$RECORDNUMBER" 1>> $FUNCTIONREFTBLE
  RECORDNUMBER=`expr $RECORDNUMBER + 1` 
}

## The following is just a function called later
PrintHeader()
{
  i=0
  OutRecord[0]="#Func_Def_Key" 
  OutRecord[1]="Number_Of_Args" 
  OutRecord[2]="Ref_File_Name" 
  OutRecord[3]="Ref_File_Line" 
  OutRecord[4]="Line_Count" 
  OutRecord[5]="Def_File_Name" 
  OutRecord[6]="Def_Func_Name" 
  OutRecord[7]="Def_File_Line" 
  OutRecord[8]="Upper_Function" 
  while [ $i -lt ${FIELDS} ]
  do
    printf "%s	" "${OutRecord[i]}" 1>> $FUNCTIONREFTBLE
    let "i=$i+1"
  done
  printf "%s	record num\n" "${OutRecord[i]}" 1>> $FUNCTIONREFTBLE
}

## The following is just a function called later
## Sometimes in a C/C++ program you can call assembly code
## directly oh nO
###
##
##
FindAsms()
{
    typeset -i -x RECORDS
    export RECORDS=0
    if [ -f ${ASMTABLE} ]
    then
       rm ${ASMTABLE}
    fi 
    typeset -i -x LNE
    LNE=1
    gobjdump -S $EXENAME | ggrep -A 7 " asm[  ]*(" \
    | ggrep "^[ ,0-9,a-f,A-F]*:"| head -1 | while read line
    do
       ASMADDR=`echo $line | gawk '{print $1}' | sed 's/://'`
       OutRecord[5]="<NULL>"
       OutRecord[6]="asm"
       OutRecord[7]="<NULL>"
       OutRecord[2]=`gaddr2line $ASMADDR -e $EXENAME | gawk \
       '{\
        split($0,c,":");
        print c[1]
        }'`
       if [ "${OutRecord[2]}x" == "x" ]
       then
          OutRecord[2]="<NULL>"
       fi
     
       OutRecord[8]="<NULL>"
       OutRecord[3]=`gaddr2line $ASMADDR -e $EXENAME | gawk \
       '{\
        split($0,c,":");
        print c[2]
        }'`

       if [ "${OutRecord[3]}x" == "x" ]
       then
          OutRecord[3]="<NULL>"
       fi

       OutRecord[4]="<NULL>"
       OutRecord[1]="<NULL>"
       OutRecord[0]="<NULL>"
       i=0
       while [ $i -lt ${FIELDS} ]
       do
           printf "%s	" "${OutRecord[i]}" >> ${ASMTABLE}
           i=`expr $i + 1` 
       done
       printf "%s\n" "${OutRecord[i]}" >> ${ASMTABLE}
       RECORDS=`expr $RECORDS + 1`
    done
    if [ -f ${ASMTABLE} ]
    then
       ASMRECS=`wc -l ${ASMTABLE} | gawk '{print $1}'`
    else
       ASMRECS=0
    fi
    echo $ASMRECS
}

### this is were the program starts
### The funcref.bash gets called in ect.bash as follows
## sorry .. The second argument is different
## Looks like there are 3 arguments.
### Callcount is the number of calls there are in objdump.txt..
### Let me open ect.bash and show you
### funcref.bash /opt/newect_2.0.1/ect/data/SAXPrint.DB/objdump.txt /tmp/xerces../bin/SAXPrint "Callcount"

if [ $# -lt 2 ] 
then
   echo "usage " $0 "<objdump output> <object>"
   exit 1
fi

if [ $# -gt 3 ] 
then
   echo "usage " $0 "<objdump output> <object>"
   exit 1
fi

APPROXCALLS=0
if [ $# -eq 3 ]
then
    APPROXCALLS=$3
fi

# don't need to worry about the next few lines.. I don't think they are used 
# at all 
let PSYN=0
typeset -i -x RECORDNUMBER
typeset -i -x PRECORDVAL 
RECORDNUMBER=0
typeset -i -x FIELDS
FIELDS=8
PSERIESSYN="	bl	"
INTELSYN="	call "

if [ "${DB}x" == "x" ]
then
    DB=.
fi

#### 
# The following three files will be created by the time this script ends.
#
ADD2FUNCTABLE=$DB/FunctionAddress.tbl
ASMTABLE=${DB}/Asmsfound.tmp
FUNCTIONREFTBLE=${DB}/tFunctionRef.tbl

EXENAME=$2

#### The following is the file created in 10-20% range
# Let's take a look at the contents of this file
## It has the function name.. the location it is defined..( file + line )
FUNCTIONDEFTABLE=$DB/tFunctionDef.tbl

PSYN=0

## clean up old files. start fresh
if [ -f $ADD2FUNCTABLE ];
then
   rm $ADD2FUNCTABLE 
fi

if [ -f $FUNCTIONREFTBLE ]
then
  rm $FUNCTIONREFTBLE
fi

## call this function. Let go to this function
## That's the header in the other screen
PrintHeader

ASMFIND=`FindAsms `
RECORDNUMBER=`expr $RECORDNUMBER + $ASMFIND`


CALLCNT="$APPROXCALLS"

$ECTBIN/genObjFr.exe  $1 $DB/funcref.bash.out1 

TFILE=$DB/tFunctionDef.tbl
gawk ' /  / { gsub( "  ", " ") } / global constructors keyed to/ { sub( " global constructors keyed to", "") } { print $0 }'  < ${TFILE} > ${TFILE}.int 

gc++filt < ${TFILE}.int | gawk '  /)\([[:print:]]*)/ { gsub( ")([[:print:]]*)", ")")}{ print $0 }' > ${TFILE}.tmp

$ECTBIN/crtFuncRef.exe $DB/funcref.bash.out1 ${TFILE}.tmp

rm -f ${TFILE}.int
#mv -f ${TFILE}.tmp ${TFILE}

if [ -f ${ASMTABLE} ]
then
    cat ${ASMTABLE} 1>> $FUNCTIONREFTBLE
    rm ${ASMTABLE}
fi     

if [ -f FunctionAddress.tbl ]
then
    rm FunctionAddress.tbl
fi
