#!/bin/bash 

if [ $# -lt 1 ] 
then
   echo "usage: "$0" <objdump's output> <directory path>"
   exit 1
fi

if [[ -z ${DB} ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

if [[ -z ${OBJDUMP} ]]
then
    echo "Missing assignment"
    echo "    OBJDUMP environment variable not set"
    exit 1
fi

if [[ -z ${ECTBIN} ]]
then
    echo "Missing assignment"
    echo "    ECTBIN environment variable not set"
    exit 1
fi

SIZETABLE=${DB}/sizes.tbl

ggrep " size" $1 | ggrep id | ggrep -v bitsize | ggrep -v "union " \
     | ggrep "^[[:blank:]]*struct" | sed 's/;//' > T_structure.txt
ggrep typedef $1 | ggrep " id " | sed 's/;//' > T_typedef.txt
gawk -f ${ECTBIN}/awktypedefsizes.awk T_typedef.txt
gawk -f ${ECTBIN}/awkstructsizes.awk  T_structure.txt
gawk -f ${ECTBIN}/anonsizes.awk $1
gawk -f ${ECTBIN}/anonsizes2.awk $1
$2/getsize $SIZETABLE 
ggrep "^typedef" ${OBJDUMP}  | ggrep -v "/\* [[:print:]]* \*/" | gawk -f ${ECTBIN}/typedefs.awk
sort -u ${SIZETABLE} > $SIZETABLE.tmp
#rm T_typedef.txt T_structure.txt
mv $SIZETABLE.tmp $SIZETABLE 
