#!/bin/bash 
#
# Linux Compatablity Tool Summary Display script
#

if [[ -z $DB ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

numFiles=`sed -n '$=' ${DB}/sourcelist.list`
numWarns=`sort -u  ${DB}/tSourceMsgs.tbl | gawk -F"	" '{print $3}' | ggrep -c W`
numErrs=`sort -u  ${DB}/tSourceMsgs.tbl | gawk -F"	" '{print $3}' | ggrep -c E`

# Clear out line being used for summary data ...
echo "                                                             "
echo "	Found ${numWarns} warnings and"
echo "	      ${numErrs} errors in"
echo "	      ${numFiles} files"

exit 0
