# (C) Copyright International Business Machines (IBM),  2005
# Useable and distributable only with IBM permission and under
# IBM terms and conditions. It may not be copied or further distributed unless
# authorized in writing by IBM.
BEGIN {
E1001 = 0
E2001 = 0
E3001 = 0
E4001 = 0
E5001 = 0
E5002 = 0
E5003 = 0
E6001 = 0
E6002 = 0
E7001 = 0
E7002 = 0
E8001 = 0
E8002 = 0
E8003 = 0
E8004 = 0
E8005 = 0
}
/E1001/{ E1001++ }
/E2001/{ E2001++ }
/E3001/{ E3001++ }
/E4001/{ E4001++ }
/E5001/{ E5001++ }
/E5002/{ E5002++ }
/E5003/{ E5003++ }
/E6001/{ E6001++ }
/E6002/{ E6002++ }
/E6002/{ E6003++ }
/E7001/{ E7001++ }
/E7002/{ E7002++ }
/E8001/{ E8001++ }
/E8002/{ E8002++ }
/E8003/{ E8003++ }
/E8004/{ E8004++ }
/E8005/{ E8005++ }
END {
 TOTAL = E1001+E2001+E3001+E4001+E5001+E5002+E5003+E6001+E6002+E6003+E7001+E7002+E8001+E8002+E8003+E8004+E8005
 print TOTAL "\tTotal Items identified\n" 
 if ( TOTAL > 0 )
 {
   if ( E1001 > 0) print  E1001 "\tE1001 Items: File path does not exist on Linux"
   if ( E2001 > 0 ) print E2001 "\tE2001 Items: Path to file has changed on Linux"
   if ( E3001 > 0 ) print E3001 "\tE3001 Items: Directory structure does not exist on Linux"
   if ( E4001 > 0 ) print E4001 "\tE4001 Items: Directory structure or file path may not map directly on Linux"
   if ( E5001 > 0 ) print E5001 "\tE5001 Items: Configuration file does not exist on Linux"
   if ( E5002 > 0 ) print E5002 "\tE5002 Items: Comparable Linux Configuration file may exist"
   if ( E5003 > 0 ) print E5003 "\tE5003 Items: Configuration file may have different options or format"
   if ( E6001 > 0 ) print E6001 "\tE6001 Items: File does not exist on Linux"
   if ( E6002 > 0 ) print E6002 "\tE6002 Items: Command may not exist on Linux"
   if ( E6003 > 0 ) print E6003 "\tE6003 Items: Commands that are unrelated to the Linux commands with the same name."
   if ( E7001 > 0 ) print E7001 "\tE7001 Items: Comparable Linux Command may exist"
   if ( E7002 > 0 ) print E7002 "\tE7002 Items: Solaris OS contains several versions of a command"
   if ( E8001 > 0 ) print E8001 "\tE8001 Items: Command flags may be different on Linux "
   if ( E8002 > 0 ) print E8002 "\tE8002 Items: Commonly used flags may be different on Linux "
   if ( E8003 > 0 ) print E8003 "\tE8003 Items: Uncommonly used flags may be different on Linux "
   if ( E8004 > 0 ) print E8004 "\tE8004 Items: Completely different or conflicting flag usage with Linux "
   if ( E8005 > 0 ) print E8005 "\tE8005 Items: Commands that may have different output"

   print "\n+++ Possible Error Code Resolutions"
   if ( E1001 > 0 ) print "E1001 Consult Linux man pages to determine if a comparable Linux path exists for these files."
   if ( E2001 > 0 ) print "E2001 Update the script to use Linux Path for this command"
   if ( E3001 > 0 ) print "E3001 Consult Linux man pages to determine if an equivalent directory structure exists on Linux"
   if ( E4001 > 0 ) print "E4001 Consult Linux man pages to determine the path the script should use."
  
   if ( E5001 > 0 ) print "E5001 Consult Linux man pages to determine if a comparable Configuration file exists on Linux"
   if ( E5002 > 0 ) print "E5002 Update the script to use the Linux Configuration file or files"
   if ( E5003 > 0 ) print "E5003 Consult man pages to determine proper config file options for Linux"

   if ( E6001+E6002+E6003 > 0 ) print "E6001-E6003 Consult Solaris OS and Linux man pages to find a comparable Linux Command"

   if ( E7002 > 0 ) {
	print "E7002 Determine which version of the Solaris OS command you are using and consult the Linux man pages"
 	print "\tto determine how to get the same behavior for this command on Linux"
   }
   if ( E8001+E8002+E8003+E8004 > 0) {
        print "E8001-E8004 Consult Solaris OS and Linux man pages to determine correct flags to use for these commands"
   }
   if ( E8005 > 0 ) print "E8005 Consult man pages to determine if command output affects your script"
 }
}
